=encoding utf8

=head1 NAME

Mail::Message::Field::AddrGroup - A group of Mail::Message::Field::Address objects

=head1 INHERITANCE

 Mail::Message::Field::AddrGroup
   is a User::Identity::Collection::Emails
   is a User::Identity::Collection
   is a User::Identity::Item

=head1 SYNOPSIS

  my $g = Mail::Message::Field::AddrGroup->new(name => 'name');

  my $a = Mail::Message::Field::Address->new(...);
  $g->addAddress($a);

  my $f = Mail::Message::Field::Addresses->new;
  $f->addGroup($g);

=head1 DESCRIPTION

An address group collects a set of e-mail addresses (in this case they
are L<Mail::Message::Field::Address|Mail::Message::Field::Address> objects).

Extends L<"DESCRIPTION" in User::Identity::Collection::Emails|User::Identity::Collection::Emails/"DESCRIPTION">.

=head1 OVERLOADED

Extends L<"OVERLOADED" in User::Identity::Collection::Emails|User::Identity::Collection::Emails/"OVERLOADED">.

=over 4

=item overload: B<""> stringification

Returns the L<string()|Mail::Message::Field::AddrGroup/"METHODS"> value.
Improves base, see L<User::Identity::Collection/"OVERLOADED">

=item overload: B<@{}> array dereference

Inherited, see L<User::Identity::Collection/"OVERLOADED">

=back

=head1 METHODS

Extends L<"METHODS" in User::Identity::Collection::Emails|User::Identity::Collection::Emails/"METHODS">.

=over 4

=item $obj-E<gt>B<string>()

Returns the address group as string.  When no name is specified, it will
only be a comma separated list of addresses.  With a name, the groups
name will be prepended and a semi-colon appended.  When no addresses
where included and there is no name, then C<undef> is returned.

=back

=head2 Constructors

Extends L<"Constructors" in User::Identity::Collection::Emails|User::Identity::Collection::Emails/"Constructors">.

=over 4

=item $obj-E<gt>B<coerce>($object)

Coerce an C<$object> into a L<Mail::Message::Field::AddrGroup|Mail::Message::Field::AddrGroup>.  Currently,
you can only coerce L<User::Identity::Collection::Emails|User::Identity::Collection::Emails> (which is
the base class for this one) into this one.

=item $class-E<gt>B<new>( [$name], %options )

Inherited, see L<User::Identity::Collection::Emails/"Constructors">

=back

=head2 Attributes

Extends L<"Attributes" in User::Identity::Collection::Emails|User::Identity::Collection::Emails/"Attributes">.

=over 4

=item $obj-E<gt>B<description>()

Inherited, see L<User::Identity::Item/"Attributes">

=item $obj-E<gt>B<itemType>()

Inherited, see L<User::Identity::Collection/"Attributes">

=item $obj-E<gt>B<name>( [$newname] )

Inherited, see L<User::Identity::Item/"Attributes">

=item $obj-E<gt>B<roles>()

Inherited, see L<User::Identity::Collection/"Attributes">

=back

=head2 Collections

Extends L<"Collections" in User::Identity::Collection::Emails|User::Identity::Collection::Emails/"Collections">.

=over 4

=item $obj-E<gt>B<add>($collection, $role)

Inherited, see L<User::Identity::Item/"Collections">

=item $obj-E<gt>B<addCollection>( $object | <[$type], %options> )

Inherited, see L<User::Identity::Item/"Collections">

=item $obj-E<gt>B<collection>($name)

Inherited, see L<User::Identity::Item/"Collections">

=item $obj-E<gt>B<parent>( [$parent] )

Inherited, see L<User::Identity::Item/"Collections">

=item $obj-E<gt>B<removeCollection>($object|$name)

Inherited, see L<User::Identity::Item/"Collections">

=item $any-E<gt>B<type>()

Inherited, see L<User::Identity::Item/"Collections">

=item $obj-E<gt>B<user>()

Inherited, see L<User::Identity::Item/"Collections">

=back

=head2 Maintaining roles

Extends L<"Maintaining roles" in User::Identity::Collection::Emails|User::Identity::Collection::Emails/"Maintaining roles">.

=over 4

=item $obj-E<gt>B<addRole>($role|([$name], %options))

Inherited, see L<User::Identity::Collection/"Maintaining roles">

=item $obj-E<gt>B<removeRole>($role|$name)

Inherited, see L<User::Identity::Collection/"Maintaining roles">

=item $obj-E<gt>B<renameRole>( <$role|$oldname>, $newname )

Inherited, see L<User::Identity::Collection/"Maintaining roles">

=item $obj-E<gt>B<sorted>()

Inherited, see L<User::Identity::Collection/"Maintaining roles">

=back

=head2 Searching

Extends L<"Searching" in User::Identity::Collection::Emails|User::Identity::Collection::Emails/"Searching">.

=over 4

=item $obj-E<gt>B<find>($name|CODE|undef)

Inherited, see L<User::Identity::Collection/"Searching">

=back

=head2 Addresses

=over 4

=item $obj-E<gt>B<addAddress>(STRING|$address|%options)

Add one e-mail address to the list which is maintained in the group. This
is a wrapper around L<addRole()|User::Identity::Collection/"Maintaining roles"> adding flexibility on how addresses
are specified.  An C<$address> can be anything which is acceptable for
L<Mail::Message::Field::Address::coerce()|Mail::Message::Field::Address/"Constructors"> or a list of options which
will create such an object.

» example: of adding an address to an address group

  my @data = (full_name => "Myself", address => 'me@tux.org');
  $group->addAddress(@data);

  my $addr = Mail::Message::Field::Address->new(@data);
  $group->addAddress(@data);

  my $ma = Mail::Address->new(...);
  $group->addAddress($ma);

=item $obj-E<gt>B<addresses>()

Returns all addresses defined in this group.  The addresses will be
ordered alphabetically to make automated testing possible: roles are
stored in a hash, so have an unpredictable order by default.

» example: getting all addresses from a group

  my @addrs = $group->addresses;
  my @addrs = map $_->address, $self->roles; #same

=back

=head2 Error handling

=head1 DIAGNOSTICS

=over 4

=item Error: cannot coerce a $type into a $class.

Cast by C<coerce()>

=item Error: cannot create a $type to add this to my collection.

Some options are specified to create a C<$type> object, which is native to
this collection.  However, for some reason this failed.
Cast by C<addRole()>

=item Error: cannot load collection module for $type ($class): $@

Either the specified C<$type> does not exist, or that module named C<$class> returns
compilation errors.  If the type as specified in the warning is not
the name of a package, you specified a nickname which was not defined.
Maybe you forgot the 'require' the package which defines the nickname.
Cast by C<addCollection()>

=item Error: cannot rename $from into $to: already exists.

Cast by C<renameRole()>

=item Error: cannot rename $from into $to: doesn't exist.

Cast by C<renameRole()>

=item Error: invalid collection $name.

The collection with C<$name> does not exist and can not be created.
Cast by C<add()>

=item Error: this $object is not a collection.

Cast by C<addCollection()>

=item Error: wrong type of role for $collection: requires a $expect but got a $type.

Each C<$collection> groups sets of roles of one specific type (C<$expect>).  You
cannot add objects of a different C<$type>.
Cast by C<addRole()>

=back

=head1 SEE ALSO

This module is part of Mail-Message version 4.03,
built on January 26, 2026. Website: F<http://perl.overmeer.net/CPAN/>

=head1 LICENSE

For contributors see file ChangeLog.

This software is copyright (c) 2001-2026 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

